<template>
  <div :class="{ loading: !Boolean(menu) }">
    <template v-if="restaurant.preorderEnabled">
      <cart v-if="Boolean(cart.length)" @toggle="openCartPanel" :data="cart" />
      <dish-panel
        v-if="selectedDish"
        @close="closeDishExtraSelector"
        @done="addToCart"
        :cart="cart"
        :data="selectedDish"
        :orderValue="dishValue"
        :disabled="!preorderTimes()"
      />
      <cart-panel
        v-if="cartPanelOpened"
        ref="cart"
        @close="closeCartPanel"
        @remove="removeFromCart"
        @dateChanged="updateDate"
        @timeChanged="updateTime"
        @openDishPanel="updateCart"
        @createOrder="openSkmpayPanel"
        @updateNote="updateNote"
        @updateItemCount="addToCart"
        :note="note"
        :time="time || ''"
        :times="preorderTimes()"
        :date="dateValue"
        :dates="preorderDates"
        :restaurant="restaurant"
        :data="cart"
      />

      <skmpay-panel
        v-if="skmpayPanelOpened"
        @close="closeSkmpayPanel"
        @submit="createOrder"
      >
      </skmpay-panel>

      <!-- <div class="section time" ref="timeSelector">
        <div class="section-content">
          <time-selector
            ref="selector"
            @dateChanged="dateChanged"
            @timeChanged="timeChanged"
            :preorderStarted="restaurant.preorderStarted"
            :disabled="!preorderTimes().length"
            :dates="preorderDates"
            :date="dateValue"
            :times="preorderTimes()"
            :time="time"
          />
        </div>
      </div> -->

      <template v-if="menu">
        <div
          class="section"
          v-for="category in menu.Categories"
          :key="category.id"
          v-show="getProducts(category).length"
          :ref="'category-' + category.id"
        >
          <h3 class="section-title">
            <a
              :id="`category-anchor-${category.name}`"
              @click="anchorClicked"
              class="category-anchor"
              :href="`#${category.name}`"
            >
              <svg
                class="octicon octicon-link"
                viewBox="0 0 16 16"
                version="1.1"
                width="16"
                height="16"
                aria-hidden="true"
              >
                <path
                  fill-rule="evenodd"
                  d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"
                ></path>
              </svg>
            </a>
            {{ category.name }}
          </h3>
          <div class="dishes">
            <dish
              v-for="product in getProducts(category)"
              :readonly="!restaurant.preorderStarted || !preorderTimes().length"
              :count="count(product)"
              :key="product.id"
              @select="openDishExtraSelector(product)"
              :data="product"
            />
          </div>
        </div>
      </template>
      <template v-else>
        <div class="section">
          <h3 class="section-title"><span class="lp"></span></h3>
          <div class="dishes">
            <dish />
            <dish />
          </div>
        </div>
      </template>
    </template>
    <template v-else>
      <div class="preorder-disabled">
        <div class="preorder-message">
          餐廳未開放<br />
          線上訂餐
        </div>
      </div>
    </template>
  </div>
</template>

<script>
import _ from "underscore";
import moment from "moment";
import { mapState, mapActions, mapGetters } from "vuex";
import * as Api from "@/api";
import Cart from "./Preorder/Cart";
import Dish from "./Preorder/Dish";
import CartPanel from "./Preorder/CartPanel";
import DishPanel from "./Preorder/DishPanel";
import TimeSelector from "./Preorder/TimeSelector";
import restaurant from "../../store/restaurant";
import { inViewport } from "@/utils";
import * as groupPresenter from "@/presenters/group";
import Cookies from "js-cookie";
import BranchSelector from "@/components/BranchSelector";
import PopupFull from "@/components/PopupFull";
import store from "@/store";
import SkmpayPanel from "../Skmpay/Panel";

export default {
  beforeRouteLeave(to, from, next) {
    if (this.cart && this.cart.length && to.name !== "SkmpayInfo") {
      // console.log(this.$parent.showWarning);
      this.$parent.showWarning = true;
    } else {
      next();
    }
  },
  async beforeRouteEnter(from, to, next) {
    try {
      await store.dispatch("branch/getBranches");
      await store.dispatch("branch/getAreas");

      next();
    } catch (err) {
      next();
      // NOTE: handle error below.
    }
  },

  components: {
    TimeSelector,
    Dish,
    Cart,
    DishPanel,
    CartPanel,
    BranchSelector,
    PopupFull,
    SkmpayPanel
  },

  data() {
    return {
      time: this.$route.query.time || "",
      date: this.$route.query.date
        ? moment(this.$route.query.date, "YYYY-MM-DD").toDate()
        : new Date(),
      note: "",
      selectedDish: null,
      cartPanelOpened: false,
      skmpayPanelOpened: false,
      menu: null,
      products: null,
      cart: [],
      sectionKeys: [],
      dishValue: null,
      creating: false,
      showBranchSelectorPopup: false,
      selectedPreorderTime: this.time,
      selectedPreorderDate: this.date
        ? moment(this.date, "YYYY-MM-DD").toDate()
        : null,
      tabs: this.$t("restaurant.tab")
    };
  },

  computed: {
    ...mapState(["locale"]),
    ...mapState("restaurant", [
      "restaurant",
      "loading",
      "changePreorderSection"
    ]),
    ...mapState("account", ["account"]),
    ...mapState("branch", {
      selection: "select",
      isMatchDeliveryScope: "isMatchDeliveryScope"
    }),
    ...mapGetters({
      branchOptions: "branch/branchOptions",
      cityOptions: "branch/cityOptions",
      areaOptions: "branch/areaOptions"
    }),

    hasAddress() {
      return (
        this.selection.city && this.selection.area && this.selection.address
      );
    },

    preorderDates() {
      return groupPresenter.preorderDates();
    },

    dateValue() {
      return moment(this.date)
        .startOf("day")
        .toDate();
    }
  },

  watch: {
    changePreorderSection(section) {
      if (section) {
        this.gotoSection(section);
        this.setChangePreorderSection(null);
      }
    },
    menu(menu) {
      if (menu) {
        this.$nextTick(this.hashChange);
      }
    },
    $route: function() {
      this.openReuestedDish();
    }
  },
  methods: {
    ...mapActions(["show"]),
    ...mapActions("account", ["startLogin"]),
    ...mapActions("restaurant", [
      "setPreorderSections",
      "setChangePreorderSection",
      "setCurrentPreorderSection"
    ]),
    ...mapActions("branch", ["openBranchSelectorPopup"]),

    hashChange() {
      const hash = decodeURIComponent(location.hash.slice(1));
      const target = document.getElementById(`category-anchor-${hash}`);

      if (hash && target) {
        target.scrollIntoView();
      }
    },

    anchorClicked() {
      setTimeout(this.hashChange);
    },

    trackPageView() {
      window.gtag("event", `pageview`, {
        event_category: "美食地圖外送",
        event_label: JSON.stringify({
          category: this.restaurant.buildingAddress,
          value: this.restaurant.company.name
        })
      });
    },

    trackSelectItem(dish) {
      window.gtag("event", `pageview`, {
        event_category: "美食地圖外送選擇餐點",
        event_label: JSON.stringify({
          category: this.restaurant.buildingAddress,
          value: this.restaurant.company.name,
          content: dish.name + " " + dish.price
        })
      });
    },

    dateChanged(date) {
      this.date = date;
      this.$router.push({
        query: Object.assign({}, this.$route.query, {
          date: moment(date).format("YYYY-MM-DD")
        })
      });
    },

    timeChanged(time) {
      this.time = time;
      this.$router.push({
        query: Object.assign({}, this.$route.query, {
          time
        })
      });
    },

    preorderTimes() {
      const today = moment().format("YYYY-MM-DD");
      return this.restaurant.preorderTimes(
        moment(this.date).format("YYYY-MM-DD") === today
      );
    },

    gotoSection(section) {
      this.sectionListener(false);
      const ref = this.$refs[section.key];
      this.$scrollTo(ref[0] || ref, 500, {
        onDone: () => {
          this.sectionListener(true);
        }
      });
    },

    updateCart(value) {
      this.openDishExtraSelector(value.dish);
      this.dishValue = value;
    },

    openDishExtraSelector(dish) {
      this.trackSelectItem(dish);
      if (!this.account) {
        this.show();
        this.startLogin();
        return;
      }
      if (!this.hasAddress) {
        this.openBranchSelectorPopup({
          isDeliveryPopup: true,
          companyId: this.$route.params.companyId,
          id: this.$route.params.id
        });
        return;
      }
      this.$router.push({
        name: this.$route.name,
        params: this.$route.params,
        query: {
          ...(this.$route.query || {}),
          itemid: dish.id
        }
      });
    },

    openReuestedDish() {
      if (!this.$route.query.itemid) {
        return;
      }
      if (!this.account) {
        this.show();
        this.startLogin();
        return;
      }
      this.selectedDish = this.products[this.$route.query.itemid];
      if (!this.selectedDish) {
        this.closeDishExtraSelector();
      }
    },

    closeDishExtraSelector() {
      this.selectedDish = null;
      this.dishValue = null;
      const query = { ...this.$route.query };
      delete query.itemid;
      this.$router.push({
        name: this.$route.name,
        params: this.$route.params,
        query
      });
    },

    openCartPanel() {
      this.cartPanelOpened = true;
    },

    closeCartPanel() {
      this.cartPanelOpened = false;
    },

    openSkmpayPanel() {
      if (!~this.preorderTimes().indexOf(this.time)) {
        alert(this.$t("cartPanel.unavailableTimeMessage"));
        return;
      }
      this.closeCartPanel();
      this.skmpayPanelOpened = true;
    },

    closeSkmpayPanel() {
      this.skmpayPanelOpened = false;
    },

    getProducts(category) {
      return category.productIds
        .map(productId => this.products[productId])
        .filter(Boolean)
        .filter(product => product.status);
    },

    getValueInCart(dish) {
      return this.cart.find(oldValue => oldValue.dish.id === dish.id);
    },

    removeCartCookie() {
      Cookies.remove("preorder_cart");
    },

    saveCartCookie() {
      const ssid = Cookies.get("ssid");
      if (!this.account || !ssid) {
        this.removeCartCookie();
        return;
      }
      let cartCookie = JSON.parse(JSON.stringify(this.cart));
      for (let i of cartCookie) {
        delete i.dish.description;
        delete i.dish.image;
      }
      Cookies.set(
        "preorder_cart",
        JSON.stringify({
          ssid: ssid,
          restaurantId: this.restaurant.id,
          cart: cartCookie
        })
      );
    },

    loadCartCookie() {
      const ssid = Cookies.get("ssid");
      if (!this.account || !ssid) {
        this.removeCartCookie();
        return;
      }
      let cartCookieData = JSON.parse(Cookies.get("preorder_cart") || "{}");
      if (cartCookieData.restaurantId) {
        if (
          cartCookieData.restaurantId === this.restaurant.id &&
          cartCookieData.ssid === ssid
        ) {
          this.cart = cartCookieData.cart || [];
        } else {
          this.removeCartCookie();
        }
      }
    },

    addToCart(value) {
      var cart = this.cart.slice();
      if (cart.length > 0) {
        const totalCount = cart
          .map(x => x.count)
          .reduce((acc, cur) => {
            return acc + cur;
          });
        console.log(totalCount);
      }

      const oldValue = cart.find(oldValue => oldValue.id === value.id);
      if (oldValue) {
        const index = cart.indexOf(oldValue);
        cart.splice(index, 1);
      }
      cart.push(value);
      this.cart = cart;
      this.saveCartCookie();
      this.closeDishExtraSelector();
    },

    removeFromCart(item) {
      this.cart = this.cart.filter(cartItem => cartItem.id !== item.id);
      this.saveCartCookie();
    },

    removeProductFromCart(product) {
      this.cart = this.cart.filter(cartItem => cartItem.dish.id !== product.id);
      this.saveCartCookie();
    },

    count(product) {
      return this.cart
        .filter(item => item.dish.id === product.id)
        .reduce((count, item) => count + item.count, 0);
    },

    updateTime(val) {
      this.time = val;
    },

    updateDate(val) {
      this.date = val;
    },

    updateNote(note) {
      this.note = note;
    },

    createOrder(ProgApiContent) {
      if (this.creating) {
        return;
      }
      if (!~this.preorderTimes().indexOf(this.time)) {
        alert(this.$t("cartPanel.unavailableTimeMessage"));
        return;
      }
      this.removeCartCookie();
      this.creating = true;
      const now = new Date();
      const data = {
        cname: this.restaurant.qlieerCName,
        cart: this.cart,
        note: this.note,
        reservationTimeText: this.time,
        reservationTime: Math.floor(
          new Date(
            moment(this.date).format("YYYY/MM/DD") + " " + this.time
          ).getTime() / 1000
        ),
        restaurant: {
          logo: this.restaurant.logo,
          language: this.locale,
          companyName: this.restaurant.company.name,
          branchName: this.restaurant.name,
          companyId: this.restaurant.company.id,
          branchId: this.restaurant.id,
          buildingId: this.restaurant.buildingId,
          floor: this.restaurant.floor,
          groupId: this.restaurant.groupId
        },
        meta: this.restaurant.groupMeta,
        // new data
        TakeOutOrDelivery: "Delivery",
        DeliveryFee: this.restaurant.groupMeta.deliveryFee || 0,
        SendCity: this.selection.city,
        SendArea: this.selection.area,
        Sendaddress: this.selection.address,
        memcart: {
          MemberId: this.account.data.memberId,
          MemberPhone: this.account.data.phoneNumber,
          MemberLevel: this.account.data.level,
          MemberName: this.account.data.name,
          MemberCard: this.account.data.cardNumb,
          SessionToken: this.account.data.SessionToken
        }
      };
      Api.Order.createOrder(data, ProgApiContent, cartId => {
        this.$router.push({
          name: this.$route.name,
          query: {
            ...this.$route.query,
            cart_id: cartId
          }
        });
      })
        .catch(err => {
          if (err.unavailableProducts) {
            alert(
              this.$t("restaurantPreorder.unavailableProducts", {
                products: err.unavailableProducts
                  .map(product => product.name)
                  .join(", ")
              })
            );
            err.unavailableProducts.forEach(product =>
              this.removeProductFromCart(product)
            );
            const products = { ...this.products };
            err.unavailableProducts.forEach(product => {
              products[product.id].status = 0;
            });
            this.products = products;
            return;
          }
          throw err;
        })
        .then(res => {
          sessionStorage.setItem(
            "skmpayData",
            JSON.stringify({
              temp: {
                timer: Date.now(),
                path: this.$route.path,
                OrderType: "Delivery"
              },
              res,
              CartSkmPayConnect: {
                ProgApiContent: "CartSkmPayConnect",
                TokenContent: null,
                DataContent: {
                  OrderId: res.id,
                  OrderSendName: "",
                  OrderSendPhone: "",
                  OrderSendEmail: "",
                  InvoiceData: {
                    InvoiceInfo: "",
                    PhoneVehicleNumber: "",
                    HumanVehicleNumber: "",
                    DonateInvoiceNumber: "",
                    CompanyVat: "",
                    CompanyTitle: ""
                  },
                  MemberCart: {
                    ...res.member
                  }
                }
              }
            })
          );
          this.$router.push({
            name: "SkmpayInfo"
          });
        });
    },

    detectSection: _.throttle(function() {
      let el, found;
      const keys = this.sectionKeys.slice();
      keys.unshift("timeSelector");
      keys.forEach(key => {
        el = this.$refs[key];
        el = (el && el[0]) || el;

        if (el && inViewport(el, { threshold: 0.5 })) {
          this.setCurrentPreorderSection(key);
        }
      });
    }, 100),

    sectionListener(bool) {
      if (bool) {
        window.addEventListener("scroll", this.detectSection);
      } else {
        window.removeEventListener("scroll", this.detectSection);
      }
    },

    openPreorderTutorialPage() {
      this.$router.push(`/preorder-tutorial`);
    }
  },

  mounted() {
    this.setCurrentPreorderSection("timeSelector");
    this.detectSection();
    this.sectionListener(true);
    this.trackPageView();
    Api.Order.getTakeOutMenu({ qlieercname: this.restaurant.qlieerCName })
      .then(res => {
        if (!res) {
          return;
        }
        this.menu = res;
        this.products = res.Products.reduce((map, product) => {
          map[product.id] = product;
          return map;
        }, {});
        const sections = [];
        res.Categories.forEach(category => {
          if (this.getProducts(category).length) {
            sections.push({
              key: "category-" + category.id,
              name: category.name
            });
          }
        });
        this.sectionKeys = sections.map(({ key }) => key);
        this.setPreorderSections(sections);
      })
      // restore cart
      .then(() => {
        const cartId = this.$route.query.cart_id;
        if (cartId) {
          return Api.Order.getCart(cartId);
        } else {
          this.loadCartCookie();
        }
      })
      .then(data => {
        if (data) {
          this.cart = data.cart;
          this.time = ~this.preorderTimes().indexOf(data.reservationTime)
            ? data.reservationTime
            : this.preorderTimes()[0];
          if (data.reservationTimestamp) {
            this.date = new Date(data.reservationTimestamp);
          }
        }
      })
      // open dish panel
      .then(() => {
        this.openReuestedDish();
      });
  },

  destroyed() {
    this.sectionListener(false);
  }
};

function createTimeFilter() {
  const now = moment();
  const date = now.format("YYYY/MM/DD");
  return time => now.isBefore(new Date(date + " " + time));
}
</script>

<style lang="scss" scoped>
.category-anchor {
  float: left;

  margin-left: -20px;
  padding-right: 4px;
  visibility: hidden;
  vertical-align: middle;
}

.section {
  &.time {
    padding: 20px 0;
  }

  @include media-breakpoint-up(md) {
    margin-bottom: 20px;
  }
}

.section-content {
  padding: 0 20px;

  @include media-breakpoint-up(md) {
    padding: 0 30px;
  }
}

.section-title {
  padding: 0 20px;
  line-height: 28px;
  background: $color-genesis-white;
  font-size: 12px;
  color: $color-primary-grey;
  font-weight: normal;
  margin: 0;

  &:hover .category-anchor {
    visibility: visible;
  }

  .lp {
    display: inline-block;
    vertical-align: middle;
    width: 48px;
    height: 12px;
  }

  @include media-breakpoint-up(md) {
    background: transparent;
    font-size: 21px;
    color: $color-primary-black;
    font-weight: 500;
    line-height: 1.62;
    padding: 0 30px;
    margin-bottom: 18px;
  }
}

.dishes {
  @include media-breakpoint-up(md) {
    display: flex;
    flex-wrap: wrap;
    margin: 0 30px 0 15px;
  }
}

.preorder-disabled {
  border: 1px $color-silver-grey solid;
  width: 255px;
  height: 135px;
  color: $color-pigeon-grey;
  border-radius: 16px;
  margin: 80px auto;
  text-align: center;

  &::after {
    content: "";
    display: inline-block;
    height: 100%;
    vertical-align: middle;
  }
}

.preorder-message {
  display: inline-block;
  font-size: 30px;
  vertical-align: middle;
  font-weight: 500;
  margin-bottom: 10px;
}
</style>
